"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.uniqueRandom = uniqueRandom;

var _crypto = _interopRequireDefault(require("crypto"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

/* eslint-disable */
// Simple pseudo-randomness that's based on a simple fingerprinting
// Used so the order of backends is always the same on a computer
function iisNode() {
  return typeof process !== 'undefined' && !!process.version;
}

function uniqueRandom(maxNonInclusive) {
  var isNode = iisNode();
  var version = isNode ? process.version : navigator.userAgent;
  var offset = new Date().getTimezoneOffset();
  var languages = isNode ? 'node' : navigator.languages == null ? navigator.language : navigator.languages.toString();
  var allString = version + offset + languages;

  var hash = _crypto["default"].createHash('md5').update(allString).digest();

  var r = 0;

  for (var i = 0; i < hash.length; i++) {
    r += hash[i];
    r %= maxNonInclusive;
  }

  return r;
}